//
//  ConversationsNodeProtocols.swift
//  VKExt
//
//  Created programmist_NA on 24.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit
import SwiftyVK

//MARK: Wireframe -
protocol ConversationsNodeWireframeProtocol: class {
    func openConversation(from conversation: Conversation)
    func openProfile(userId: Int)
}
//MARK: Presenter -
protocol ConversationsNodePresenterProtocol: class {
    func start()
    func onTapConversation(at conversation: Conversation)
    func onTapPerformProfile(userId: Int)
    func onTapReadConversation(with peerId: Int)
    func onTapUnreadConversation(with peerId: Int)
    func onChangeSilenceMode(peerId: Int, sound: Int)
    func onDeleteConversation(peerId: Int)
    func onHandleError(error: VKError)
    func onEvent(message: String, _ style: MessageViewState)
}

//MARK: Interactor -
protocol ConversationsNodeInteractorProtocol: class {
    var presenter: ConversationsNodePresenterProtocol?  { get set }
    func start()
    func readMessage(peerId: Int)
    func markAsUnreadConversation(peerId: Int)
    func setSilenceMode(peerId: Int, sound: Int)
    func deleteConversation(peerId: Int)
}

//MARK: View -
protocol ConversationsNodeViewProtocol: class {
    var presenter: ConversationsNodePresenterProtocol?  { get set }
    func showStatusError(message: String, error: ErrorLocalize?, _ style: MessageViewState, with isLoading: Bool)
}
